------------------------------------------------------------------------------------------
-- OptionWindow file
-- Written by Homeopatix
-- 26 january 2021
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
-- define size of the window
------------------------------------------------------------------------------------------
local windowWidth = 0;
local windowHeight = 0;

windowWidth = 1030;
windowHeight = 810;
------------------------------------------------------------------------------------------
-- create the options window
------------------------------------------------------------------------------------------
function GenerateOptionsWindowTokens()
		OptionsWindowTokens=Turbine.UI.Lotro.GoldWindow(); 
		OptionsWindowTokens:SetSize(windowWidth, windowHeight); 
		OptionsWindowTokens:SetText(T[ "PluginOptionsText" ]); 

		OptionsWindowTokens.Message=Turbine.UI.Label(); 
		OptionsWindowTokens.Message:SetParent(OptionsWindowTokens); 
		OptionsWindowTokens.Message:SetSize(150,10); 
		OptionsWindowTokens.Message:SetPosition(windowWidth/2 - 75, windowHeight - 17 ); 
		OptionsWindowTokens.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter); 
		OptionsWindowTokens.Message:SetText(T[ "PluginText" ]); 
		
		OptionsWindowTokens:SetZOrder(0);
		OptionsWindowTokens:SetWantsKeyEvents(true);

		OptionsWindowTokens:SetPosition((Turbine.UI.Display:GetWidth()-OptionsWindowTokens:GetWidth())/2,(Turbine.UI.Display:GetHeight()-OptionsWindowTokens:GetHeight())/2);

		OptionsWindowTokens:SetVisible(false);
		------------------------------------------------------------------------------------------
		-- option center panel --
		------------------------------------------------------------------------------------------
		posx = 50;
		posy = 60;

		colorUsedFortexte = Turbine.UI.Color.Lime;
		colorUsedForLines = Turbine.UI.Color.Blue;

		TitleDisplayer(OptionsWindowTokens, posx, posy, T[ "PluginOptionTokens1" ], colorUsedFortexte, colorUsedForLines);

		posy = posy + 10;

		OptionsWindowTokens.Message=Turbine.UI.Label(); 
			OptionsWindowTokens.Message:SetParent(OptionsWindowTokens); 
			OptionsWindowTokens.Message:SetSize(300, 40); 
			OptionsWindowTokens.Message:SetPosition(OptionsWindowTokens:GetWidth()/2 - 150, posy ); 
			OptionsWindowTokens.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter); 
			OptionsWindowTokens.Message:SetFont(Turbine.UI.Lotro.Font.Verdana16);
			OptionsWindowTokens.Message:SetText(T[ "PluginOptionTokens0" ]); 

			checkBoxToken = {};
			-------------------------------------------------------------------
			-- first token -- Yule token
			-------------------------------------------------------------------
			posy = posy + 45;

			for i=1, nbrTokens do
				

				nameTmp = "TokenName" .. i;
				
				checkBoxToken[i] = Turbine.UI.Lotro.CheckBox();
				checkBoxToken[i]:SetParent( OptionsWindowTokens );
				checkBoxToken[i]:SetSize(250, 40); 
				checkBoxToken[i]:SetFont(Turbine.UI.Lotro.Font.Verdana16);
				checkBoxToken[i]:SetText(" " .. T[ nameTmp ]);
				checkBoxToken[i]:SetPosition(posx + 50, posy);
				checkBoxToken[i]:SetVisible(true);
				if(settings["displayToken" .. i]["value"] == true)then
					checkBoxToken[i]:SetChecked(true);
				else
					checkBoxToken[i]:SetChecked(false);
				end
				checkBoxToken[i]:SetForeColor( Turbine.UI.Color( 0.7, 0.6, 0.2 ));

				if(i % 20 == 0)then
					posx = posx + 310;
					posy = 115;
				else
					posy = posy + 30;
				end
			end


			posy = posy + 50;
			

			buttonValider = Turbine.UI.Lotro.GoldButton();
			buttonValider:SetParent( OptionsWindowTokens );
			buttonValider:SetPosition(windowWidth/2 - 125,  windowHeight - 50);
			buttonValider:SetSize( 300, 20 );
			buttonValider:SetFont(Turbine.UI.Lotro.Font.Verdana16);
			buttonValider:SetText( T[ "PluginOptionValidate" ] );
			buttonValider:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
			buttonValider:SetVisible(true);
			buttonValider:SetMouseVisible(true);


		ValidateChangesOptionsTokens();
		ClosingTheWindowOptionsTokens();

		hudVisible=true; -- the actual HUD state is not exposed to Lua so we have to assume the HUD is visible when the plugin loads
		if(settings["isOptionsWindowVisible"]["value"] == true)then
			UIWindowVisible=true;
		else
			UIWindowVisible=false;
		end-- used to retain the state of the window for when the HUD is toggled back on

		OptionsWindowTokens.KeyDown=function(sender, args)
			if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then -- hide the window due to Escape
				OptionsWindowTokens:SetVisible( false );
				settings["isOptionsWindowVisible"]["value"] = false;
			end

			if ( args.Action == 268435635 ) then -- toggle HUD (the HUD action is not defined in the Turbine.UI.Lotro.Action enumeration although it should be)
				hudVisible=not hudVisible;
				if hudVisible then
					OptionsWindowTokens:SetVisible(UIWindowVisible);
				else
					UIWindowVisible=OptionsWindowTokens:IsVisible();
					OptionsWindowTokens:SetVisible(false);
				end
			end
		end
end
------------------------------------------------------------------------------------------
-- boutton valider
------------------------------------------------------------------------------------------
function ValidateChangesOptionsTokens()
	buttonValider.MouseClick = function(sender, args)
			for i=1, nbrTokens do
				if (checkBoxToken[i]:IsChecked()) then
					settings["displayToken" .. i]["value"] = true;
				else
					settings["displayToken" .. i]["value"] = false;
				end
			end

			OptionsWindowTokens:SetVisible(false);
			settings["isOptionsWindowVisible"]["value"] = false;
			UpdateMainWindow();
		end
end
